<template lang="html">
	<div class="subpage" v-if="false">
		<div class="content">
      <butter-icon name="no-history" />
			<h2>No Orders Yet</h2>
      <p>Your order history details will be displayed here.</p>
		</div>
    <div class="actions">
      <a href="//brd.com/native/trade" class="button">Trade</a>
      <a href="//brd.com/native/buy" class="button primary">Buy</a>
    </div>
	</div>
	<flex dir="column" v-else class="transaction-history">
    <h3 class="active">In progress</h3>
    <transaction @click.native="showDetails()" label="Trade" :completed="toPrettyDateTime('2021-01-01')" :received="formatCurrency({ amount: '3.0023423434334234', currency: { code: 'ETH' } })" sent="0.0571 ETH">
      <butter-icon name="trade" />
			<butter-icon name="status-in-progress" class="status in-progress" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="0.123 BTC" sent="$507.50">
      <butter-icon name="card" />
			<butter-icon name="status-in-progress" class="status in-progress" />
    </transaction>
    <h3 class="dim">Completed</h3>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1 BTC" sent="$4,127.68" completed="Oct 2, 2021">
      <butter-icon name="bank" />
			<butter-icon name="status-completed" class="status completed" />
    </transaction>
    <transaction @click.native="showDetails()" label="Buy" received="1.225 ETH" sent="$173.83" completed="Oct 1, 2021">
      <butter-icon name="card" />
			<butter-icon name="status-failed" class="status failed" />
    </transaction>
    <modal v-show="modal.opened" title="Trade Complete" :header-class="getStatus().toLowerCase()" @close="modal.opened=false">
      <butter-icon name="close" slot="close" />
      <template slot="header">
        <div class="icon">
          <butter-icon name="transaction-success" width="75" height="75" />
        </div>
      </template>
			<flex dir="column">
	      <named-list label="From">1 BTC</named-list>
	      <named-list label="To">$32,546</named-list>
	      <named-list label="Date">{{ toPrettyDateTime('2021-01-01') }}</named-list>
	      <named-list label="Fulfilled By">Wyre</named-list>
	      <named-list label="Trandsaction ID">asdsadsads2342424324asdsadsads2342424324asdsadsads2342424324</named-list>
	      <named-list label="Delivery">2-3 hours</named-list>
			</flex>
      <template slot="actions">
				<a href="mailto:support@brd.com" class="button primary large">Email support about this order</a>
      </template>
    </modal>
	</flex>
</template>

<script>
export default {
	data() {
		return {
      modal: {
        opened: false,
        order: null,
      },
			nohistory: true
		};
	},
	methods: {
    getLabel: function(order) {
      return "Sell"
    },
    getPMIcon: function(order) {
      return `/static/icons/exchange.svg`;
    },
    getStatus: function(order) {
      return 'COMPLETE'
    },
    getStatusDisplay: function(order) {
      const status = this.getStatus(order)
      return orderStatus[status]
    },
    getStatusIcon: function(order) {
      var status = this.getStatus(order).toLowerCase()
      let icon = 'in-progress';
      if (status === 'complete') {
        icon = 'detail-success';
      }
      if (status === 'failed') {
        icon = 'detail-failed';
      }
      return `/static/icons/${icon}.svg`;
    },
    toPrettyDate: function(dateString) {
      // TODO pretty date based on locale
      var d = new Date(dateString)
      // eg bits = ["DayOfWeek", "Month", "Day", "Year"]
      var bits = d.toDateString().split(' ')
      return bits[1] + ' ' + bits[2] + ', ' + bits[3]
    },
    toPrettyDateTime: function(dateString) {
      var prettyDate = this.toPrettyDate(dateString)
      var d = new Date(dateString)
      return prettyDate + ', ' + d.toLocaleTimeString()
    },
    formatCurrency: function({ amount, currency }) {
      const code = currency.code.toUpperCase();
      if (currency.type != 'fiat') return `${this.$options.filters.trim(amount, 8)} ${code}`;
      return new Intl.NumberFormat('en-US', {
        style: 'currency',
        currency: code,
      }).format(amount);
    },
    showDetails: function(order) {
      this.modal.opened = true
    },
  },
  filters: {
    trim(num, len) {
      let decimals = '1'
      for (let i = 0; i < len; i++) {
        decimals += '0'
      }
      return Math.trunc(num * decimals) / decimals
    }
  },
}
</script>
